var Cus00800_ConsumoPlanejadoRealizadoController = function(Parametros, Query, ScreenService, General) {
    /*global getLocalVar, Configuration, moment, angular*/
    var self = this;
    this.defaultValues = function(widget) {

        if (!widget.currentRow.CDFILIAL) {
            widget.newRow();
            widget.currentRow.NMFILIAL = getLocalVar('CDFILIAL') + ' | ' + getLocalVar('NMFILIAL');
            widget.currentRow.CDFILIAL = getLocalVar('CDFILIAL');
        }

        var relatorio = widget.getField('REPORT_NAME').dataSource.getFirstRow();
        Parametros.retornaDataProcessamento().then(function(data) {
            widget.currentRow.DTREFE = data;
            var defaultValue = {
                start: data,
                formattedStart: data,
                end: data,
                formattedEnd: data
            };
            var PERIODO = widget.getField('PERIODO');
            PERIODO.value(defaultValue);

            widget.currentRow.DTINICIAL = data;
            widget.currentRow.DTFINAL = data;
            widget.currentRow.__report_name = relatorio.REPORT_NAME;
            widget.currentRow.REPORT_CODE = relatorio.REPORT_CODE;
        }, function(callback) {

        });

    };

    

    this.validaData = function(currentRow) {

        var dataInicial = currentRow.DTINICIAL ? moment(currentRow.DTINICIAL, 'DD/MM/YYYY')._d : null;
        var dataFinal = currentRow.DTFINAL ? moment(currentRow.DTFINAL, 'DD/MM/YYYY')._d : null;
        var mensagem = "Período inválido";

        if (dataInicial && dataFinal && dataFinal < dataInicial) {
            ScreenService.showMessage(mensagem);
            return false;
        }
        return true;
    };

    this.atualizaListaDeServico = function(widget) {
        var grupoServicos = '';
        var currentRow = widget.currentRow;

        if (currentRow.ALLGRUPSERV == 'N') {
            if (currentRow.NMGRUPSERV.length) {
                grupoServicos = currentRow.NMGRUPSERV.join('_');
            }
            else {
                grupoServicos = '';
            }
        }
        else {
            grupoServicos = 'T';
        }
        General.onClickDependentField(widget.getField('NMSERVICO'), {
            CDFILIAL: currentRow.CDFILIAL,
            CDGRUPSERV: grupoServicos
        });
    };

    this.geraDataSource = function(widget, dataSource) {
        var dataSourceNivelProd = [];
        var maiorNivel = getLocalVar('CDPICTPROD').split('.').length;

        for (var i = 0; i < maiorNivel; i++) {
            dataSourceNivelProd.push({
                value: i.toString(),
                name: i.toString()
            });
        }
        widget.getField('NIVEL').dataSource.data = dataSourceNivelProd;
    };

    this.agruparNivel = function(widget, currentRow) {
        var fieldNivel = widget.getField('NIVEL');

        if (currentRow.NIVEL == 0) {
            fieldNivel.currentRow = 'N';
        }
        else {
            fieldNivel.currentRow = 'S';
        }
    };

    this.validaDiferenca = function(widget, currentRow) {

        if (currentRow.DIFERPERC) {
            widget.getField('DIFERPERC').validations = {
                "max": {
                    "value": 100
                }
            };
            return true;
        }
        else if (!currentRow.DIFERPERC) {
            return true;
        }
        else {
            return false;
        }
    };

    this.getNivelNumChars = function(nivel) {
        var nCharsPorNivel = [];
        var mascara = getLocalVar('CDPICTPROD');
        nCharsPorNivel = mascara.split('.');
        nCharsPorNivel[0] = nCharsPorNivel[0].length;
        for (let i = 1; i < nCharsPorNivel.length; i++) {
            nCharsPorNivel[i] = nCharsPorNivel[i - 1] + nCharsPorNivel[i].length;
        }
        if (!nivel && nivel !== 0) {
            return nCharsPorNivel;
        }
        else {
            return nCharsPorNivel[nivel];
        }
    };

    this.validaNivel = function(currentRow) {
        var mensagem = "O produto final não pode ser maior que o inicial.";
        var retorno = General.comparaPratoProduto(currentRow.CDARVPRODINICIAL, currentRow.CDARVPRODFINAL, getLocalVar('CDPICTPROD'));
        if (!retorno) {
            ScreenService.showMessage(mensagem);
            return false;
        }
        return true;
    };

    this.openReport = function(widget, currentRow) {
        if (widget.isValid()) {
            var reportName = currentRow.REPORT_NAME;
            if (currentRow.NIVEL > 0)
                currentRow.NRTAMACNIVEL = self.getNivelNumChars(currentRow.NIVEL - 1);

            if (self.validaData(currentRow) && self.validaNivel(currentRow)) {
                if (self.validaDiferenca(widget, currentRow)) {
                    var reportFormats = [
        			    {
        			        name: "pdf",
        			        value: "PDF"
        			    },
        			    {
        			        name: "xlsx",
        			        value: "XLSX"
        			    }
        			];
        			widget.currentRow.DIFERPERC = widget.currentRow.DIFERPERC.toString().split(',').join('.');
                    General.openReportPopup(widget, self.abreRelatorio, [widget, currentRow, reportName], reportFormats);
                }
            }
        }
    };

    this.abreRelatorio = function(widget, currentRow, reportName) {

        self.agruparNivel(widget, currentRow);

        if (currentRow.ALLGRUPSERV == 'N' && currentRow.ALLCDSERVFILI == 'N') {

            currentRow.LISTAGRUPSERV = currentRow.NMGRUPSERV.join('_');
            currentRow.LISTASERV = currentRow.NMSERVICO.join('_');

        }
        else if (currentRow.ALLGRUPSERV == 'S' && currentRow.ALLCDSERVFILI == 'N') {

            currentRow.LISTAGRUPSERV = 'T';
            currentRow.LISTASERV = currentRow.NMSERVICO.join('_');

        }
        else if (currentRow.ALLGRUPSERV == 'N' && currentRow.ALLCDSERVFILI == 'S') {

            currentRow.LISTAGRUPSERV = currentRow.NMGRUPSERV.join('_');
            currentRow.LISTASERV = 'REQUEST';

        }
        else if (currentRow.ALLGRUPSERV == 'S' && currentRow.ALLCDSERVFILI == 'S') {

            currentRow.LISTAGRUPSERV = 'T';
            currentRow.LISTASERV = 'REQUEST'; //Relatório não aceita T para "Todos"
        }
        currentRow.PROD_MASK = getLocalVar('CDPICTPROD');
        currentRow.CDPRODINI = angular.copy(currentRow.CDPRODINICIAL);
        currentRow.CDPRODFIN  = angular.copy(currentRow.CDARVPRODFINAL);
        General.openReport('cus_relatorio#/cus00800_consumo_planejado_realizado', reportName, currentRow);
    }.bind(this);
    
    this.exportDateValues = function(field){
		if(field.value()){
			field.widget.currentRow.DTINICIAL = field.value().start || '';
			field.widget.currentRow.DTFINAL = field.value().end || ''; 
		}
	};
	
	this.alteraProdutoFinal = function(widget){
	  widget.currentRow.NMPRODFINAL = angular.copy(widget.currentRow.NMPRODINICIAL);
	  widget.currentRow.PRODFINAL = angular.copy(widget.currentRow.PRODINICIAL);
	  widget.currentRow.CDPRODFINAL = angular.copy(widget.currentRow.CDPRODINICIAL);
	  widget.currentRow.CDARVPRODFINAL = angular.copy(widget.currentRow.CDARVPRODINICIAL);
	};
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Cus00800_ConsumoPlanejadoRealizadoController', Cus00800_ConsumoPlanejadoRealizadoController);
});
